# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Defined types

* [`puppet_authorization`](#puppet_authorization): Define type to manage the puppetserver authorization
* [`puppet_authorization::rule`](#puppet_authorization--rule): manage a puppetserver authorization rule

### Resource types

* [`puppet_authorization_hocon_rule`](#puppet_authorization_hocon_rule): Manage the state of this type.

### Data types

* [`Puppet_authorization::Httpmethod`](#Puppet_authorization--Httpmethod): Type for validating supported HTTP methods

## Defined types

### <a name="puppet_authorization"></a>`puppet_authorization`

Define type to manage the puppetserver authorization

#### Parameters

The following parameters are available in the `puppet_authorization` defined type:

* [`version`](#-puppet_authorization--version)
* [`allow_header_cert_info`](#-puppet_authorization--allow_header_cert_info)
* [`replace`](#-puppet_authorization--replace)
* [`path`](#-puppet_authorization--path)

##### <a name="-puppet_authorization--version"></a>`version`

Data type: `Integer`

The version of the authorization

Default value: `1`

##### <a name="-puppet_authorization--allow_header_cert_info"></a>`allow_header_cert_info`

Data type: `Boolean`

Whether to allow header cert info

Default value: `false`

##### <a name="-puppet_authorization--replace"></a>`replace`

Data type: `Boolean`

Whether to replace the file

Default value: `false`

##### <a name="-puppet_authorization--path"></a>`path`

Data type: `Stdlib::Absolutepath`

The path to the auth.conf file

Default value: `$name`

### <a name="puppet_authorization--rule"></a>`puppet_authorization::rule`

manage a puppetserver authorization rule

#### Parameters

The following parameters are available in the `puppet_authorization::rule` defined type:

* [`path`](#-puppet_authorization--rule--path)
* [`ensure`](#-puppet_authorization--rule--ensure)
* [`rule_name`](#-puppet_authorization--rule--rule_name)
* [`allow`](#-puppet_authorization--rule--allow)
* [`allow_unauthenticated`](#-puppet_authorization--rule--allow_unauthenticated)
* [`deny`](#-puppet_authorization--rule--deny)
* [`match_request_method`](#-puppet_authorization--rule--match_request_method)
* [`match_request_query_params`](#-puppet_authorization--rule--match_request_query_params)
* [`sort_order`](#-puppet_authorization--rule--sort_order)
* [`match_request_path`](#-puppet_authorization--rule--match_request_path)
* [`match_request_type`](#-puppet_authorization--rule--match_request_type)

##### <a name="-puppet_authorization--rule--path"></a>`path`

Data type: `Stdlib::Absolutepath`

The path to the auth.conf file

##### <a name="-puppet_authorization--rule--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

State of rule

Default value: `'present'`

##### <a name="-puppet_authorization--rule--rule_name"></a>`rule_name`

Data type: `String`

An arbitrary name used to identity the rule

Default value: `$name`

##### <a name="-puppet_authorization--rule--allow"></a>`allow`

Data type: `Variant[Array[Variant[String, Hash]], String, Hash, Undef]`

Value(s) to permit an authenticated request

Default value: `undef`

##### <a name="-puppet_authorization--rule--allow_unauthenticated"></a>`allow_unauthenticated`

Data type: `Boolean`

Puppet Server will always permit the request (potentially insecure) when set to true.
If true, the rule cannot use the allow or deny parameters.

Default value: `false`

##### <a name="-puppet_authorization--rule--deny"></a>`deny`

Data type: `Variant[Array[Variant[String, Hash]], String, Hash, Undef]`

Value(s) to deny an authenticated request, even if an allow is also matched.

Default value: `undef`

##### <a name="-puppet_authorization--rule--match_request_method"></a>`match_request_method`

Data type: `Variant[Array[Puppet_authorization::Httpmethod], Puppet_authorization::Httpmethod, Undef]`

Limit rule to match specific HTTP request method(s).

Default value: `undef`

##### <a name="-puppet_authorization--rule--match_request_query_params"></a>`match_request_query_params`

Data type: `Hash`

Limit rule to matching query parameters with specific value(s).
An Array of values can be provided to match a request with any of the values.

Default value: `{}`

##### <a name="-puppet_authorization--rule--sort_order"></a>`sort_order`

Data type: `Integer`

Rule processing priority, 1 to 399 are evaluated before default Puppet rules, or 601 to 998 are be evaluated after Puppet.
Lower-numbered values evaluated first, and secondarily sorts lexicographically by the name string value's Unicode code points.

Default value: `200`

##### <a name="-puppet_authorization--rule--match_request_path"></a>`match_request_path`

Data type: `Optional[String]`

Match request when the endpoint URL starts with or contains the parameter value.

Default value: `undef`

##### <a name="-puppet_authorization--rule--match_request_type"></a>`match_request_type`

Data type: `Optional[Enum['path', 'regex']]`

How Puppet Server will interpret the match_request_path parameter value.

Default value: `undef`

## Resource types

### <a name="puppet_authorization_hocon_rule"></a>`puppet_authorization_hocon_rule`

Manage the state of this type.

#### Properties

The following properties are available in the `puppet_authorization_hocon_rule` type.

##### `ensure`

Valid values: `present`, `absent`

Manage the state of this type.

Default value: `present`

##### `value`

The value of the setting to be defined.

#### Parameters

The following parameters are available in the `puppet_authorization_hocon_rule` type.

* [`name`](#-puppet_authorization_hocon_rule--name)
* [`path`](#-puppet_authorization_hocon_rule--path)
* [`provider`](#-puppet_authorization_hocon_rule--provider)

##### <a name="-puppet_authorization_hocon_rule--name"></a>`name`

namevar

An arbitrary name used as the identity of the resource.

##### <a name="-puppet_authorization_hocon_rule--path"></a>`path`

The file Puppet will ensure contains the specified setting.

##### <a name="-puppet_authorization_hocon_rule--provider"></a>`provider`

The specific backend to use for this `puppet_authorization_hocon_rule` resource. You will seldom need to specify this
--- Puppet will usually discover the appropriate provider for your platform.

## Data types

### <a name="Puppet_authorization--Httpmethod"></a>`Puppet_authorization::Httpmethod`

Type for validating supported HTTP methods

Alias of `Enum['put', 'post', 'get', 'head', 'delete']`

